import java . io . File;
import java . io . FileNotFoundException;
import java . io . FileReader;
import java . io . LineNumberReader;
import java . io . IOException;



class CharacterReader
{



	private final File file;
	private LineNumberReader reader;



	CharacterReader (File file) throws FileNotFoundException
	{
		this . file = file;
		reader = new LineNumberReader (new FileReader (file));
		peeked_char = 0;
	}



	void reset () throws IOException, FileNotFoundException
	{
		reader . close ();
		reader = new LineNumberReader (new FileReader (file));
		peeked_char = 0;
	}



	private char peeked_char;



	private char get_char () throws IOException
	{
		int c = reader . read ();
		if (c == -1)
			c = 0;
		return (char) c;
	}



	char peek_char () throws IOException
	{
		if (peeked_char == 0)
			peeked_char = get_char ();
		return peeked_char;
	}



	char read_char () throws IOException
	{
		if (peeked_char != 0)
		{
			char c = peeked_char;
			peeked_char = 0;
			return c;
		}
		else
			return get_char ();
	}



	int get_line_number ()
	{
		return reader . getLineNumber ();
	}



}



