class CompileError extends Exception
{



	static final int
		COLON_EXPECTED_AFTER_LABEL    = 0,
		DUPLICATE_LABEL               = 1,
		LABEL_OR_INSTRUCTION_EXPECTED = 2,
		OPEN_PAREN_EXPECTED           = 3,
		COMMA_EXPECTED                = 4,
		CLOSE_PAREN_EXPECTED          = 5,
		POSITIVE_INTEGER_EXPECTED     = 6,
		UNDEFINED_LABEL               = 7;



	final Token offending_token;



	private static String get_message (int type, Token offending_token)
	{
		String error_string = "Error, line " + offending_token . line_number + ": ";
		switch (type)
		{
		case COLON_EXPECTED_AFTER_LABEL:
			return error_string + "Colon expected after label.";
		case DUPLICATE_LABEL:
			return error_string + "Duplicate label \"" + ((LabelToken) offending_token) . label + "\".";
		case LABEL_OR_INSTRUCTION_EXPECTED:
			return error_string + "Label or instruction expected.";
		case OPEN_PAREN_EXPECTED:
			return error_string + "Open parenthesis expected.";
		case COMMA_EXPECTED:
			return error_string + "Comma expected.";
		case CLOSE_PAREN_EXPECTED:
			return error_string + "Close parenthesis expected.";
		case POSITIVE_INTEGER_EXPECTED:
			return error_string + "Positive integer expected.";
		case UNDEFINED_LABEL:
			return error_string + "Label \"" + ((LabelToken) offending_token) . label + "\" is undefined.";
		default:
			throw new RuntimeException ("can't generate error message from unrecognized error type");
		}
	}



	public CompileError (int type, Token offending_token)
	{
		super (get_message (type, offending_token));
		this . offending_token = offending_token;
	}



}
