import java . math . BigInteger;



class NaturalMath implements BigIntegerConstants
{



	static BigInteger factor_power (BigInteger number, BigInteger factor)
	{
		BigInteger power = ZERO;
		while (true)
		{
			BigInteger [] q_and_r = number . divideAndRemainder (factor);
			if (! q_and_r [1] . equals (ZERO))
				return power;
			number = q_and_r [0];
			power = power . add (ONE);
		}
	}



	static int intValue (BigInteger big)
	{
		if (big . compareTo (BigInteger . valueOf (Integer . MAX_VALUE)) == 1)
			throw new ArithmeticException ("overflow converting BigInteger to int");
		return big . intValue ();
	}



	static BigInteger pi (BigInteger m, BigInteger n)
	{
		return TWO . pow (intValue (m)) . multiply (TWO . multiply (n) . add (ONE)) . subtract (ONE);
	}



	static BigInteger pi1 (BigInteger x)
	{
		return factor_power (x . add (ONE), TWO);
	}



	static BigInteger pi2 (BigInteger x)
	{
		return x . add (ONE) . divide (TWO . pow (pi1 (x) . intValue ())) . subtract (ONE) . divide (TWO);
	}



}



