import java . math . BigInteger;



class Processor implements BigIntegerConstants
{



	Program program = null;
	RegisterBank registers = null;
	int pc = 0;



	int run (int steps)
	{
		boolean halted = false;
		int count;
		for (count = 0; count != steps; ++ count)
		{
			Instruction instruction = program . fetch_instruction (pc);
			if (instruction == null)
			{
				halted = true;
				break;
			}
			if (instruction instanceof Z_Instruction)
			{
				Z_Instruction z = (Z_Instruction) instruction;
				registers . store (z . dest, ZERO);
				++ pc;
			}
			else if (instruction instanceof S_Instruction)
			{
				S_Instruction s = (S_Instruction) instruction;
				registers . store (s . dest, registers . load (s . dest) . add (ONE));
				++ pc;
			}
			else if (instruction instanceof T_Instruction)
			{
				T_Instruction t = (T_Instruction) instruction;
				registers . store (t . dest, registers . load (t . src));
				++ pc;
			}
			else if (instruction instanceof J_Instruction)
			{
				J_Instruction j = (J_Instruction) instruction;
				if (registers . load (j . src1) . equals (registers . load (j . src2)))
				{
					if (j . target . compareTo (BigInteger . valueOf (Integer . MAX_VALUE)) < 0)
						pc = j . target . intValue ();
					else
						pc = 0;
				}
				else
					++ pc;
			}
			else
				throw new RuntimeException ("unable to execute unrecognized instruction");
			-- steps;
		}
		if (halted)
			return count;
		else
			return -1;
	}



}



