import java . util . Vector;
import java . math . BigInteger;
import java . io . IOException;



class ProgramReader
{



	private final InstructionReader reader;



	ProgramReader (java . io . File file)
		throws java . io . FileNotFoundException
	{
		reader = new InstructionReader (file);
	}



	Program read_program (Program program) throws IOException, CompileError
	{
		// Perform first pass (to resolve labels):
		System . out . print ("Resolving labels...");
		reader . reset (false);
		Instruction instruction;
		do {
			instruction = reader . read_instruction ();
		} while (instruction != null);
		System . out . println ("done.");

		// Perform second pass (to construct program):
		System . out . print ("Loading program...");
		reader . reset (true);
		while (true)
		{
			instruction = reader . read_instruction ();
			if (instruction == null)
				break;
			program . append_instruction (instruction);
		}
		System . out . println ("done.");

		return program;
	}



}



