class Token
{



	static final int
		Z           =  0,
		S           =  1,
		T           =  2,
		J           =  3,
		OPEN_PAREN  =  4,
		CLOSE_PAREN =  5,
		COMMA       =  6,
		COLON       =  7,
		INTEGER     =  8,
		LABEL       =  9,
		ERROR       = 10,
		EOF         = 11;



	final int type;
	final int line_number;



	protected Token (int type, int line_number)
	{
		this . type = type;
		this . line_number = line_number;
	}



	static Token create (String ident, int line_number)
	{
		if (ident . equals ("Z"))
			return new Token (Z, line_number);
		else if (ident . equals ("S"))
			return new Token (S, line_number);
		else if (ident . equals ("T"))
			return new Token (T, line_number);
		else if (ident . equals ("J"))
			return new Token (J, line_number);
		else
			return new LabelToken (ident, line_number);
	}



	static Token create (char c, int line_number)
	{
		switch (c)
		{
		case '(':
			return new Token (OPEN_PAREN, line_number);
		case ')':
			return new Token (CLOSE_PAREN, line_number);
		case ',':
			return new Token (COMMA, line_number);
		case ':':
			return new Token (COLON, line_number);
		case '\0':
			return new Token (EOF, line_number);
		default:
			return new ErrorToken (c, line_number);
		}
	}



	static Token create (java . math . BigInteger integer, int line_number)
	{
		return new IntegerToken (integer, line_number);
	}



}



