﻿
namespace com.scrigner.RAMModel
{
	// ================================================================================
	// A Statement executes on a Machine and exposes an abstract Execute Method.
	// We can implement new statements by simply subclassing this abstract class and by implementing the DoExecute Hollywood method.
	// ================================================================================
	public abstract class CAbstractStatement : IStatement 
	{
		public IStatementResult Execute(IMachine machine)
		{
			CContract.AssertIsNotNull("machine", machine);

			// We delegate to the Hollywood method ...
			IStatementResult result = this.DoExecute(machine);
			// ... and we return the execution result
			return result;
		}
		protected abstract IStatementResult DoExecute(IMachine machine);

		public abstract string GetAsText();
	}
}
