﻿
using System;
using System.Collections.Generic;
namespace com.scrigner.RAMModel
{
	public interface ITape
	{
		IEnumerable<long> Values	{get;}
		void SetValue(long value, int position);
		long GetValue(int position);
	}
	public interface IMachine
	{
		ITape Tape			{get;}		// Exposing the Tape might not be a good idea ...
		//IProgram Program	{get;}
		long Execute(IProgram program);
		event EventHandler<CMachineStateEventArgs> NotifyProcessingState;
	}
	public interface IMachineState
	{
		string GetAsText();
		int StepIndex			{get;}
		int NextStatementIndex	{get;}
		IMachine Machine		{get;}
	}

	public interface IProgram
	{
		bool IsStatementDefinedAt(int iPosition);
		IStatement GetStatement(int iPosition);
	}
	public interface IStatement
	{
		//void Execute();
		string GetAsText();
		IStatementResult Execute(IMachine machine);
	}
	public interface IStatementResult
	{
		int GetNextStatementIndex();
		bool HasNextStatementOverride();
	}
	
}
