﻿
namespace com.scrigner.RAMModel
{
	public class CStatementAddOne : CAbstractStatement 
	{
		private readonly int ziPosition;	// The position being zeroed

		public CStatementAddOne(int position)
		{
			CContract.Assert(position >= 1, "position >= 1");

			ziPosition = position;
		}
		public int Position	{get{return ziPosition;}}

		protected override IStatementResult DoExecute(IMachine machine)
		{	// Here we violate Demeter's Law but we don't care ...
			long currentValue = machine.Tape.GetValue(ziPosition);

			machine.Tape.SetValue(currentValue + 1, ziPosition);

			return new CStatementResult();
		}
		public override string GetAsText()
		{
			return "s(" + ziPosition + ")";
		}
	}
}
