﻿
namespace com.scrigner.RAMModel
{
	public class CStatementZero : CAbstractStatement 
	{
		private readonly int ziPosition;	// The position being zeroed

		public CStatementZero(int position)
		{
			CContract.Assert(position >= 1, "position >= 1");

			ziPosition = position;
		}
		public int Position	{get{return ziPosition;}}

		protected override IStatementResult DoExecute(IMachine machine)
		{
			machine.Tape.SetValue(0, ziPosition);

			return new CStatementResult();
		}
		public override string GetAsText()
		{
			return "z(" + ziPosition + ")";
		}

	}
}
