﻿
namespace com.scrigner.RAMModel
{
	// This is NOT a URM statement but it is useful to definie the initial tape condition.
	public class CStatementSet : CAbstractStatement 
	{
		private readonly long zlValue;
		private readonly int ziPosition;	// The position being zeroed

		public CStatementSet(long value, int position)
		{
			CContract.Assert(position >= 1, "position >= 1");

			zlValue = value;
			ziPosition = position;
		}
		public long Value	{get{return zlValue;}}
		public int Position	{get{return ziPosition;}}

		protected override IStatementResult DoExecute(IMachine machine)
		{	
			machine.Tape.SetValue(zlValue, ziPosition);

			return new CStatementResult();
		}
		public override string GetAsText()
		{
			return "i(" + zlValue + "," + ziPosition + ")";	// i = init
		}

	}
}
